# std::out_of_range

From cppreference.com
< cpp‎ | error

Defined in header `<stdexcept>` |  |
class out_of_range; |  |

Defines a type of object to be thrown as exception. It reports errors that are consequence of attempt to access elements out of defined range.

It may be thrown by the member functions of std::bitset and std::basic_string, by std::stoi and std::stod families of functions, and by the bounds-checked member access functions (e.g. std::vector::at and std::map::at)

Inheritance diagram

### Member functions

(constructor) | constructs the exception object (public member function)

## std::out_of_range::out_of_range

explicit out_of_range( const std::string& what_arg ); | (1) |
explicit out_of_range( const char* what_arg ); | (2) | (since C++11)

Constructs the exception object with `what_arg` as explanatory string that can be accessed through what().

Because copying `std::exception` is not permitted to throw exceptions, this message is typically stored internally as a separately-allocated reference-counted string. This is also why there is no constructor taking `std::string&&`: it would have to copy the content anyway.

### Parameters

what_arg | - | explanatory string

### Exceptions

May throw std::bad_alloc

## Inherited from std::exception

### Member functions

(destructor) [virtual] | destructs the exception object (virtual public member function of `std::exception`)
what [virtual] | returns an explanatory string (virtual public member function of `std::exception`)

### Notes

The standard error condition std::errc::result_out_of_range typically indicates the condition where the result, rather than the input, is out of range, and is more closely related to std::range_error and ERANGE.

### See also

at | access specified character with bounds checking (public member function of `std::basic_string`)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/error/out_of_range&oldid=70848"